import { openBlock as n, createElementBlock as a, createElementVNode as s, renderSlot as r, ref as V, computed as b, normalizeClass as y, unref as c, createVNode as x, withCtx as v, resolveComponent as w, createBlock as k, inject as q, withDirectives as B, isRef as $, vModelDynamic as z, toDisplayString as _, createCommentVNode as m, provide as D, Fragment as C, renderList as L, onMounted as M, withModifiers as S, createTextVNode as T, vModelSelect as U, vModelText as O, vModelCheckbox as P } from "vue";
const N = (l, t) => {
  const e = l.__vccOpts || l;
  for (const [o, i] of t)
    e[o] = i;
  return e;
}, E = {}, Z = { class: "cf-app-bar" };
function G(l, t) {
  return n(), a("header", Z, [
    s("div", null, [
      r(l.$slots, "left")
    ]),
    s("div", null, [
      r(l.$slots, "right")
    ])
  ]);
}
const R = /* @__PURE__ */ N(E, [["render", G]]);
const j = { class: "cf-dropdown-body" }, H = {
  __name: "Dropdown",
  setup(l) {
    const t = V(!1), e = b(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (o, i) => (n(), a("div", {
      class: y(c(e))
    }, [
      s("div", {
        class: "cf-dropdown-toggle",
        onClick: i[0] || (i[0] = (d) => t.value = !t.value)
      }, [
        r(o.$slots, "toggle")
      ]),
      s("div", j, [
        r(o.$slots, "body")
      ]),
      s("div", {
        class: "cf-dropdown-backdrop",
        onClick: i[1] || (i[1] = (d) => t.value = !1)
      })
    ], 2));
  }
};
const X = {
  key: 0,
  class: "cf-app-bar-link"
}, J = { class: "cf-app-bar-link__label" }, K = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), Q = {
  key: 1,
  class: "cf-app-bar-link"
}, W = { class: "cf-app-bar-link__label" }, _t = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(l) {
    return (t, e) => l.dropdown ? (n(), a("div", X, [
      x(H, null, {
        toggle: v(() => [
          s("div", J, [
            r(t.$slots, "default"),
            K
          ])
        ]),
        body: v(() => [
          r(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (n(), a("button", Q, [
      s("div", W, [
        r(t.$slots, "default")
      ])
    ]));
  }
};
const pt = {
  __name: "AppBody",
  props: {
    wide: {
      type: Boolean,
      default: !1
    }
  },
  setup(l) {
    const t = l, e = b(() => ({
      "cf-app-body": !0,
      "cf-app-body--wide": t.wide
    }));
    return (o, i) => (n(), a("div", {
      class: y(c(e))
    }, [
      r(o.$slots, "default")
    ], 2));
  }
}, F = {
  to: {
    type: String,
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: {
    type: Boolean,
    default: !1
  },
  wide: {
    type: Boolean,
    default: !1
  },
  color: {
    type: String,
    default: null
  },
  loading: {
    type: Boolean,
    default: !1
  },
  disabled: {
    type: Boolean,
    default: !1
  }
};
const Y = ["type", "disabled"], ft = {
  __name: "FilledButton",
  props: F,
  setup(l) {
    const t = l, e = b(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (o, i) => {
      const d = w("router-link");
      return o.to ? (n(), k(d, {
        key: 0,
        class: y(c(e)),
        to: o.to,
        inert: t.disabled
      }, {
        default: v(() => [
          r(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (n(), a("button", {
        key: 1,
        class: y(c(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        r(o.$slots, "default")
      ], 10, Y));
    };
  }
};
const ee = ["type", "disabled"], bt = {
  __name: "OutlinedButton",
  props: F,
  setup(l) {
    const t = l, e = b(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (o, i) => {
      const d = w("router-link");
      return o.to ? (n(), k(d, {
        key: 0,
        class: y(c(e)),
        to: o.to,
        inert: t.disabled
      }, {
        default: v(() => [
          r(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (n(), a("button", {
        key: 1,
        class: y(c(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        r(o.$slots, "default")
      ], 10, ee));
    };
  }
};
const te = ["disabled"], vt = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(l) {
    const t = l;
    return (e, o) => {
      const i = w("router-link");
      return l.to ? (n(), k(i, {
        key: 0,
        class: "cf-text-button",
        to: l.to,
        inert: t.disabled
      }, {
        default: v(() => [
          r(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (n(), a("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        r(e.$slots, "default")
      ], 8, te));
    };
  }
};
const le = { class: "cf-choice" }, se = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], oe = ["for"], ne = { key: 0 }, ae = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Array],
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: String,
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, o = Math.random(), i = {
      name: q("choice-list-name", null),
      required: q("choice-list-required", null)
    }, d = b({
      get() {
        return e.modelValue;
      },
      set(u) {
        t("update:modelValue", u);
      }
    });
    return (u, f) => (n(), a("div", le, [
      B(s("input", {
        "onUpdate:modelValue": f[0] || (f[0] = (g) => $(d) ? d.value = g : null),
        type: e.type,
        id: c(o),
        name: i.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: i.required,
        disabled: e.disabled
      }, null, 8, se), [
        [z, c(d)]
      ]),
      s("label", { for: c(o) }, _(e.label || e.value), 9, oe),
      e.helper ? (n(), a("small", ne, _(e.helper), 1)) : m("", !0)
    ]));
  }
};
const ie = {
  key: 0,
  class: "cf-choice-list__label"
}, mt = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, o = b(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), i = b({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return D("choice-list-name", Math.random()), D("choice-list-required", e.required), (d, u) => (n(), a("div", {
      class: y(c(o))
    }, [
      e.label ? (n(), a("div", ie, _(e.label), 1)) : m("", !0),
      (n(!0), a(C, null, L(l.choices, (f) => (n(), k(ae, {
        key: f.value || f,
        type: e.multiple ? "checkbox" : "radio",
        label: f.label || f.value || f,
        helper: f.helper,
        value: f.value || f,
        disabled: e.disabled,
        modelValue: c(i),
        "onUpdate:modelValue": u[0] || (u[0] = (g) => $(i) ? i.value = g : null)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128))
    ], 2));
  }
};
const de = { class: "cf-sidebar-nav" }, re = /* @__PURE__ */ s("hr", null, null, -1), ue = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), ce = /* @__PURE__ */ s("span", null, "Collapse sidebar", -1), _e = [
  ue,
  ce
], pe = {
  __name: "Sidebar",
  setup(l) {
    const t = V(!1), e = b(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (o, i) => (n(), a("aside", {
      class: y(c(e))
    }, [
      s("nav", de, [
        r(o.$slots, "default"),
        re
      ]),
      s("button", {
        class: "cf-sidebar-toggle",
        onClick: i[0] || (i[0] = (d) => t.value = !t.value)
      }, _e)
    ], 2));
  }
};
const yt = {
  __name: "DefaultLayout",
  setup(l) {
    return M(() => {
      document.body.dataset.layout = "default";
    }), (t, e) => (n(), a(C, null, [
      x(R, null, {
        left: v(() => [
          r(t.$slots, "brand")
        ]),
        right: v(() => [
          r(t.$slots, "navigation")
        ]),
        _: 3
      }),
      x(pe, null, {
        default: v(() => [
          r(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      s("main", null, [
        r(t.$slots, "main")
      ])
    ], 64));
  }
};
const fe = { class: "cf-dialog-header" }, be = { key: 0 }, ve = { class: "cf-dialog-body" }, me = { class: "cf-dialog-footer" }, ye = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), he = [
  ye
], ht = {
  __name: "Dialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(l, { emit: t }) {
    const e = l, o = V(null);
    return M(() => o.value.showModal()), (i, d) => (n(), a("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: o
    }, [
      s("div", fe, [
        s("h1", null, _(e.title), 1),
        e.description ? (n(), a("div", be, _(e.description), 1)) : m("", !0)
      ]),
      s("div", ve, [
        r(i.$slots, "body")
      ]),
      s("div", me, [
        r(i.$slots, "footer")
      ]),
      s("button", {
        class: "cf-dialog-close",
        onClick: d[0] || (d[0] = (u) => t("close"))
      }, he)
    ], 512));
  }
};
const ge = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, $e = { class: "material-symbols-outlined" }, ke = { class: "cf-dropdown-item__label" }, Be = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, we = { class: "material-symbols-outlined" }, Se = { class: "cf-dropdown-item__label" }, gt = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(l) {
    const t = l, e = b(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (o, i) => {
      const d = w("router-link");
      return l.to ? (n(), k(d, {
        key: 1,
        class: y(c(e)),
        to: l.to
      }, {
        default: v(() => [
          l.icon ? (n(), a("div", Be, [
            s("span", we, _(l.icon), 1)
          ])) : m("", !0),
          s("div", Se, [
            r(o.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (n(), a("button", {
        key: 0,
        class: y(c(e))
      }, [
        l.icon ? (n(), a("div", ge, [
          s("span", $e, _(l.icon), 1)
        ])) : m("", !0),
        s("div", ke, [
          r(o.$slots, "default")
        ])
      ], 2));
    };
  }
};
const Ve = { class: "cf-drop-zone" }, xe = ["onDrop"], Ce = { class: "cf-drop-zone-box__label" }, qe = { class: "cf-drop-zone-box__action" }, De = /* @__PURE__ */ s("span", null, "select from device", -1), ze = ["required"], Le = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, Me = {
  key: 1,
  class: "cf-drop-zone-list"
}, Ne = /* @__PURE__ */ s("div", { class: "cf-drop-zone-list__header" }, null, -1), Fe = { class: "cf-drop-zone-list__item" }, Ae = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ s("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Ie = [
  Ae
], $t = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue", "cancel"],
  setup(l, { emit: t }) {
    const e = l, o = V(null), i = b(() => !!(e.required && !e.modelValue)), d = b(() => {
      if (e.modelValue) {
        const p = (e.modelValue.size / 1048576).toFixed(0), I = (p / 1e3).toFixed(1);
        return p < 100 ? `${p} MB` : `${I} GB`;
      } else
        return "0 MB";
    }), u = (h) => {
      const p = h.target.files[0];
      g(p);
    }, f = (h) => {
      const p = h.dataTransfer.files[0];
      g(p);
    }, g = (h) => {
      const p = parseInt(e.max) * 1048576;
      p && p < h.size ? (o.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : t("update:modelValue", h);
    }, A = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (h, p) => (n(), a("div", Ve, [
      l.modelValue ? (n(), a("div", Me, [
        Ne,
        s("div", Fe, [
          s("div", null, _(e.modelValue.name), 1),
          s("div", null, _(c(d)), 1),
          s("button", { onClick: A }, Ie)
        ])
      ])) : (n(), a("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: S(f, ["prevent"]),
        onDragenter: p[0] || (p[0] = S(() => {
        }, ["prevent"])),
        onDragover: p[1] || (p[1] = S(() => {
        }, ["prevent"])),
        onDragleave: p[2] || (p[2] = S(() => {
        }, ["prevent"]))
      }, [
        s("div", Ce, _(e.label), 1),
        s("label", qe, [
          T(" Drag and drop or "),
          De,
          s("input", {
            type: "file",
            ref_key: "input",
            ref: o,
            required: c(i),
            onChange: u
          }, null, 40, ze)
        ]),
        e.max ? (n(), a("div", Le, " Files larger than " + _(e.max) + " MB cannot be uploaded ", 1)) : m("", !0)
      ], 40, xe))
    ]));
  }
};
const Te = { class: "cf-field" }, Ue = ["required", "disabled"], Oe = {
  key: 0,
  value: null
}, Pe = ["value"], Ee = ["required", "disabled"], Ze = ["type", "list", "required", "disabled"], Ge = { key: 3 }, Re = { key: 4 }, kt = {
  __name: "Field",
  props: {
    modelValue: [Number, String],
    type: String,
    label: String,
    options: Array,
    list: String,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, o = b({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return (i, d) => (n(), a("div", Te, [
      e.type === "select" ? B((n(), a("select", {
        key: 0,
        class: "cf-field__input",
        "onUpdate:modelValue": d[0] || (d[0] = (u) => $(o) ? o.value = u : null),
        required: e.required,
        disabled: e.disabled
      }, [
        e.required ? m("", !0) : (n(), a("option", Oe)),
        (n(!0), a(C, null, L(e.options, (u) => (n(), a("option", {
          key: u.value || u,
          value: u.value || u
        }, _(u.label || u), 9, Pe))), 128))
      ], 8, Ue)), [
        [U, c(o)]
      ]) : e.type === "textarea" ? B((n(), a("textarea", {
        key: 1,
        class: "cf-field__input",
        "onUpdate:modelValue": d[1] || (d[1] = (u) => $(o) ? o.value = u : null),
        required: e.required,
        disabled: e.disabled
      }, null, 8, Ee)), [
        [O, c(o)]
      ]) : B((n(), a("input", {
        key: 2,
        class: "cf-field__input",
        "onUpdate:modelValue": d[2] || (d[2] = (u) => $(o) ? o.value = u : null),
        type: e.type,
        list: e.list,
        required: e.required,
        disabled: e.disabled
      }, null, 8, Ze)), [
        [z, c(o)]
      ]),
      e.label ? (n(), a("label", Ge, _(e.label), 1)) : m("", !0),
      e.helper ? (n(), a("small", Re, _(e.helper), 1)) : m("", !0)
    ]));
  }
};
const je = ["value", "max"], Bt = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(l) {
    const t = l;
    return (e, o) => (n(), a("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, _(l.value) + "% ", 9, je));
  }
};
const He = { class: "cf-sidebar-link__icon" }, Xe = { class: "material-symbols-outlined" }, Je = { class: "cf-sidebar-link__label" }, Ke = ["href"], Qe = { class: "cf-sidebar-link__icon" }, We = { class: "material-symbols-outlined" }, Ye = { class: "cf-sidebar-link__label" }, wt = {
  __name: "SidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(l) {
    const t = l;
    return (e, o) => {
      const i = w("router-link");
      return l.to ? (n(), k(i, {
        key: 0,
        class: "cf-sidebar-link",
        to: t.to
      }, {
        default: v(() => [
          s("div", He, [
            s("span", Xe, _(l.icon), 1)
          ]),
          s("div", Je, [
            r(e.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (n(), a("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: l.href
      }, [
        s("div", Qe, [
          s("span", We, _(l.icon), 1)
        ]),
        s("div", Ye, [
          r(e.$slots, "default")
        ])
      ], 8, Ke));
    };
  }
};
const et = {}, tt = { class: "cf-spinner" }, lt = /* @__PURE__ */ s("div", null, null, -1), st = /* @__PURE__ */ s("div", null, null, -1), ot = /* @__PURE__ */ s("div", null, null, -1), nt = /* @__PURE__ */ s("div", null, null, -1), at = [
  lt,
  st,
  ot,
  nt
];
function it(l, t) {
  return n(), a("div", tt, at);
}
const St = /* @__PURE__ */ N(et, [["render", it]]);
const dt = { class: "cf-switch" }, rt = ["value", "true-value", "false-value", "disabled"], ut = {
  key: 0,
  class: "cf-switch__label"
}, Vt = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, o = b({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return (i, d) => (n(), a("div", dt, [
      B(s("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": d[0] || (d[0] = (u) => $(o) ? o.value = u : null),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, rt), [
        [P, c(o)]
      ]),
      e.label ? (n(), a("div", ut, _(e.label), 1)) : m("", !0)
    ]));
  }
};
export {
  R as CfAppBar,
  _t as CfAppBarLink,
  pt as CfAppBody,
  ae as CfChoice,
  mt as CfChoiceList,
  yt as CfDefaultLayout,
  ht as CfDialog,
  H as CfDropdown,
  gt as CfDropdownItem,
  $t as CfDropzone,
  kt as CfField,
  ft as CfFilledButton,
  bt as CfOutlinedButton,
  Bt as CfProgress,
  pe as CfSidebar,
  wt as CfSidebarLink,
  St as CfSpinner,
  Vt as CfSwitch,
  vt as CfTextButton
};
